Bug 1669913 (python-pyscaffold) - Review Request: python-pyscaffold - Template tool for putting up the scaffold of a Python project
Summary: Review Request: python-pyscaffold - Template tool for putting up the scaffold...
Status: CLOSED ERRATA
Alias: python-pyscaffold
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Luis Bazan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2019-01-27 23:43 UTC by Ankur Sinha (FranciscoD)
Modified: 2019-02-17 02:27 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2019-02-17 02:27:15 UTC
bazanluis20: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2019-01-27 23:43:08 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-pyscaffold/python-pyscaffold.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-pyscaffold/python-pyscaffold-3.1-1.fc29.src.rpm

Description: 
PyScaffold helps you setup a new Python project.

PyScaffold comes with a lot of elaborated features and configuration defaults
to make the most common tasks in developing, maintaining and distributing your
own Python package as easy as possible.

Fedora Account System Username: ankursinha

Comment 1 J. Scheurich 2019-01-28 22:00:17 UTC
rpmlint find errors

$ rpmlint python3-pyscaffold-3.1-1.fc30.noarch.rpm
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/conftest_py.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/setup_py.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/skeleton.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/test_skeleton.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/travis_install.template 644 /bin/bash 
python3-pyscaffold.noarch: W: no-manual-page-for-binary putup
1 packages and 0 specfiles checked; 5 errors, 1 warnings.

Comment 2 Ankur Sinha (FranciscoD) 2019-01-28 22:09:45 UTC
Thanks for the check. 

Those are false positives. These files are templates used by the package and they contain shebangs for that purpose. They are not scripts really.

Cheers,
Ankur

Comment 3 Elliott Sales de Andrade 2019-01-29 00:54:52 UTC
Then if those are generic template files, should you really be replacing env in the shebang?

Comment 4 Ankur Sinha (FranciscoD) 2019-01-29 09:29:23 UTC
Yes, because on Fedora, the whole python tool chain will only support py3. There is no need to rely on /usr/bin/env.

Comment 5 Luis Bazan 2019-01-29 16:22:03 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file license_affero_3.0.template is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-pyscaffold-3.1-1.fc30.noarch.rpm
          python-pyscaffold-doc-3.1-1.fc30.noarch.rpm
          python-pyscaffold-3.1-1.fc30.src.rpm
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/conftest_py.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/setup_py.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/skeleton.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/test_skeleton.template 644 /usr/bin/python3 
python3-pyscaffold.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/pyscaffold/templates/travis_install.template 644 /bin/bash 
python3-pyscaffold.noarch: W: no-manual-page-for-binary putup
3 packages and 0 specfiles checked; 5 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
python-pyscaffold-doc (rpmlib, GLIBC filtered):

python3-pyscaffold (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3-setuptools
    python3-setuptools_scm
    python3dist(pytest-runner)



Provides
--------
python-pyscaffold-doc:
    python-pyscaffold-doc

python3-pyscaffold:
    python3-pyscaffold
    python3.7dist(pyscaffold)
    python3dist(pyscaffold)



Source checksums
----------------
https://files.pythonhosted.org/packages/source/P/PyScaffold/PyScaffold-3.1.tar.gz :
  CHECKSUM(SHA256) this package     : 2286368ce628142f9ba090a3fc401065a1b1fcb8fff7ee21b7f6fa83a3c01bcb
  CHECKSUM(SHA256) upstream package : 2286368ce628142f9ba090a3fc401065a1b1fcb8fff7ee21b7f6fa83a3c01bcb


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1669913
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 6 Luis Bazan 2019-01-29 16:27:46 UTC
Approved!

Cheers,

Comment 7 Ankur Sinha (FranciscoD) 2019-01-29 17:01:43 UTC
Thanks very much!

Repo requested: https://pagure.io/releng/fedora-scm-requests/issue/9547

Comment 8 Gwyn Ciesla 2019-01-29 17:16:48 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-pyscaffold

Comment 9 Fedora Update System 2019-01-29 18:55:49 UTC
python-pyscaffold-3.1-1.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-6f6ff97a6b

Comment 10 Fedora Update System 2019-01-30 01:59:02 UTC
python-pyscaffold-3.1-1.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-6f6ff97a6b

Comment 11 Elliott Sales de Andrade 2019-01-30 02:44:53 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #4)
> Yes, because on Fedora, the whole python tool chain will only support py3.
> There is no need to rely on /usr/bin/env.

For things that only exist in Fedora yes, but are these not generic templates to produce Python *packages* that you might put on, e.g., PyPI?

Comment 12 Ankur Sinha (FranciscoD) 2019-01-30 11:25:11 UTC
They are, but to use them for py2, one needs to use the py2 version of pyscaffold which we are not providing (cannot provide either since many of the deps do not provide py2 variants either). Like other packages, users that wish to use the py2 version will have to use virtualenvs and pip.

Comment 13 Elliott Sales de Andrade 2019-02-03 03:43:16 UTC
I'm not talking about Python 2, but about putting packages on PyPI. If you put scripts on there with /usr/bin/python3, then they will not use the virtualenv python (whether it's 2 or 3).

But now that I look at it a little closer, I don't think any of these files actually need a shebang, and it should be removed. I will open a PR for it upstream.

Comment 14 Fedora Update System 2019-02-17 02:27:15 UTC
python-pyscaffold-3.1-1.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.